//
//  AddServerPanelController.java
//  CocoDonkey
//  $Id: AddServerPanelController.java,v 1.2 2002/06/09 21:02:00 fortun Exp $
//
//  Created by Fred Bonzoun on Mon May 27 2002.
//  Copyright (c) 2002 Bonzoun. All rights reserved.
//
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation; either version 2.1 of the License, or
//  (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

import net.bonzoun.cocodonkey.*;

/***
 * This controller controls the AddServerPanel panel.
 * It allows the user to enter a new server to connect to.
 ***/
public class AddServerPanelController extends WindowController {

    NSTextField hostnameField; /* IBOutlet */
    NSTextField portField; /* IBOutlet */

    private DonkeyTalker talker;

    /***
     * This controller does not show the window. It's creation must be followed by a call to showWindow()
     * @param talker The DonkeyTalker to talk to
     ***/
    public AddServerPanelController(DonkeyTalker talker) {
        super("AddServerPanel");
        this.talker = talker;
    }

    /***
     * Just closes the window
     ***/
    public void cancelAction(Object sender) { // IBAction
        window().close();
    }

    /***
     * Adds the requested server and closes the window.
     * No error handling if the entered information is completly wrong.
     ***/
    public void okAction(Object sender) { // IBAction
        talker.addAServer(hostnameField.stringValue(), portField.stringValue());
        window().close();
    }

}
