//
//  Ed2kLinkPanelController.java
//  CocoDonkey
//  $Id: Ed2kLinkPanelController.java,v 1.3 2002/07/14 22:34:57 fortun Exp $
//
//  Created by Fred Bonzoun on Sun May 19 2002.
//  Copyright (c) 2002 Bonzoun. All rights reserved.
//
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation; either version 2.1 of the License, or
//  (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

import net.bonzoun.cocodonkey.*;

public class Ed2kLinkPanelController extends WindowController {

    NSTextField ed2kLinkField; /* IBOutlet */

    private DonkeyTalker talker;
    
    public Ed2kLinkPanelController(DonkeyTalker talker) {
        super("Ed2kLinkPanel");
        this.talker = talker;
    }
    
    public void cancel(Object sender) { // IBAction
        window().close();
    }

    public void save(Object sender) { // IBAction
        String url = ed2kLinkField.stringValue();
        // We translate the '%' escape chars
        while (url.indexOf("%7C")>=0 || url.indexOf("%20")>=0)
            url = java.net.URLDecoder.decode(url);
        // We translate some accents
        StringBuffer out = new StringBuffer(url.length());
        for(int i=0; i<url.length(); i++) {
            char c = url.charAt(i);
            switch(c) {
                case '':
                case '':
                case '':
                    out.append('e');
                    break;
                case '':
                case '':
                    out.append('a');
                    break;
                case '':
                case '':
                    out.append('u');
                    break;
                case '':
                    out.append('o');
                    break;
                case '':
                    out.append('c');
                    break;
                default:
                    out.append(c);
                    break;
            }
        }
        url = out.toString();
        // Let's go now
        talker.download(url);
        window().close();
    }

}

// $Log: Ed2kLinkPanelController.java,v $
// Revision 1.3  2002/07/14 22:34:57  fortun
// We now remove (most of) all accents before submitting to the daemon
//
// Revision 1.2  2002/07/07 01:18:35  fortun
// Decodes e2dk urls (if URLEncoded)
//
// Revision 1.1.1.1  2002/05/21 21:26:10  fortun
//
//
