//
//  CamlFile.java
//  CocoDonkey
//	$Id: CamlFile.java,v 1.1 2002/08/21 21:51:31 fortun Exp $
//
//  Created by Frederic Ortun on Wed Aug 21 2002.
//  Copyright (c) 2002 Bonzoun. All rights reserved.
//
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation; either version 2.1 of the License, or
//  (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

package net.bonzoun.cocodonkey;

import java.io.*;
import java.util.Date;

public class CamlFile {

    private File file;
    private long modTime;
    private CamlData data;
    
    public CamlFile(String fname) {
        file = new File(fname);
    }

    /*** Returns the parsed content of the file. This is always updated when needed ***/
    public CamlData data() {
        long t = file.lastModified();
        if (t != modTime) {
            modTime = t;
            data = CamlParser.parse(file);
        }
        return data;
    }

    /*** Returns the parsed content of the file. This is not updated ***/
    public CamlData lastData() {
        return data;
    }
}

// $Log: CamlFile.java,v $
// Revision 1.1  2002/08/21 21:51:31  fortun
// *** empty log message ***
//
