//
//  DonkeyLauncher.java
//  CocoDonkey
//  $Id: DonkeyLauncher.java,v 1.9 2002/09/24 20:52:39 fortun Exp $
//
//  Created by Fred Bonzoun on Sat May 11 2002.
//  Copyright (c) 2002 Bonzoun. All rights reserved.
//
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation; either version 2.1 of the License, or
//  (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

package net.bonzoun.cocodonkey;

import com.apple.cocoa.foundation.*;
import com.apple.cocoa.application.*;

import java.io.*;

public class DonkeyLauncher {

    public static void launchLocalDonkey(String daemonDir, DonkeyTalker talker) throws IOException {
        new File(daemonDir + "/searches.ini.tmp").delete();
        File dir = new File(daemonDir);
        Util.launchShell("\"" + daemonDir + "/mldonkey\" </dev/null >/tmp/mldonkey.console &", dir);
        //Process p = Runtime.getRuntime().exec(new String[]{daemonDir + "/mldonkey"},
        //                                      new String[]{}, dir);
        for(int i=0; i<10; i++) {
            try {
                talker.connect(10000);
                return;
            }
            catch(IOException e) {
                try {
                    Thread.sleep(1000);
                }
                catch(InterruptedException e2) {
                }
            }
        }
        throw new IOException("Cannot connect");
    }

    public static boolean hardKillCore() {
        return Util.launchShell("kill `ps axww|grep '/mldonkey'|grep -v grep|awk '{print $1}'`", null);
    }
}

// $Log: DonkeyLauncher.java,v $
// Revision 1.9  2002/09/24 20:52:39  fortun
// Bug if the path to mldonkey contains a space char
//
// Revision 1.8  2002/07/09 22:09:54  fortun
// killCore() is now back to the daemonOptionsController class
//
// Revision 1.7  2002/07/08 22:15:51  fortun
// killCore() now asks before hard killing the core
//
// Revision 1.6  2002/07/07 01:23:14  fortun
// Now uses a provied talker
//
// Revision 1.5  2002/07/05 18:37:50  fortun
// Current dir for shellLauncher
//
// Revision 1.4  2002/07/05 00:00:04  fortun
// Uses a logger to log the output
//
// Revision 1.3  2002/07/04 23:16:30  fortun
// The core is now better launched (output is redirected to a file)
// New killCore and hardKillCore methods
//
// Revision 1.2  2002/05/25 23:38:55  fortun
// launchLocalDonkey has been moved from DonkeyTalker
//
// Revision 1.1.1.1  2002/05/21 21:26:13  fortun
//
//
