//
//  SearchedItem.java
//  CocoDonkey
//  $Id: SearchedItem.java,v 1.4 2003/01/03 00:03:00 fortun Exp $
//
//  Created by Fred Bonzoun on Sun May 12 2002.
//  Copyright (c) 2002 Bonzoun. All rights reserved.
//
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation; either version 2.1 of the License, or
//  (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

package net.bonzoun.cocodonkey;

import com.apple.cocoa.foundation.*;
import java.util.*;

public class SearchedItem extends GenericItem {

    public String type;
    public String extension;
    public String codec;
    public String length;
    
    private List aliases = new ArrayList();
    
    /*package*/ SearchedItem(int id, String name) {
        super(id, name);
    }

    /*package*/ void addAlias(String name) {
        aliases.add(name);
    }

    /*package*/ void addBasicInfo(int size, String hash, int nbClients) {
        this.size = size;
        this.hash = hash;
        this.nbClients = nbClients;
        complete = true;
    }

    /*package*/ void addExtendedInfo(String type, String extension, String codec, String length) {
        this.type = (type==null || type.length()==0 ? null : type);
        this.extension = (extension==null || extension.length()==0 ? null : extension);
        this.codec = codec;
        this.length = length;
    }

    public String type() {
        return type;
    }

    public String extension() {
        return extension;
    }

    public String codec() {
        return codec;
    }

    public String length() {
        return length;
    }

    public List aliases() {
        return aliases;
    }

    protected boolean idIsConstant() {
        return false;
    }
}

// $Log: SearchedItem.java,v $
// Revision 1.4  2003/01/03 00:03:00  fortun
// equals() now works
//
// Revision 1.3  2002/07/22 00:30:22  fortun
// NSArrays are now Lists
//
// Revision 1.2  2002/07/21 15:15:53  fortun
// Potential bug corrected
//
// Revision 1.1.1.1  2002/05/21 21:26:13  fortun
//
//
