//
//  ServerItem.java
//  CocoDonkey
//  $Id: ServerItem.java,v 1.4 2002/07/09 22:13:33 fortun Exp $
//
//  Created by Fred Bonzoun on Sun May 12 2002.
//  Copyright (c) 2002 Bonzoun. All rights reserved.
//
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation; either version 2.1 of the License, or
//  (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

package net.bonzoun.cocodonkey;

import com.apple.cocoa.foundation.*;

public class ServerItem {

    protected int id;
    protected String ip;
    protected String name;
    protected int n1;
    protected int n2;
    protected String realIp;
    protected String realPort;

    /*package*/ ServerItem(int id, String ip, String name, int n1, int n2) {
        this.id = id;
        this.ip = ip;
        this.name = name;
        this.n1 = n1;
        this.n2 = n2;
        int p = ip.indexOf(':');
        if (p>0) {
            realIp = ip.substring(0, p);
            realPort = ip.substring(p+1);
        }
    }

    public void updateWith(ServerItem server) {
        n1 = server.n1;
        n2 = server.n2;
    }
    
    public int id() {
        return id;
    }

    public String ip() {
        return ip;
    }

    public String realIp() {
        return realIp;
    }

    public String realPort() {
        return realPort;
    }
    
    public String name() {
        return name;
    }

    public int n1() {
        return n1;
    }

    public int n2() {
        return n2;
    }

    public static abstract class MyComparator implements java.util.Comparator {
        public boolean equals(Object o) {
            return equals(o);
        }
    }

    public static class CompareName extends MyComparator {
        public final int compare(Object o1, Object o2) {
            ServerItem item1 = (ServerItem)o1;
            ServerItem item2 = (ServerItem)o2;
            if (item1.name()!=null)
                return item1.name().compareToIgnoreCase(item2.name());
            else
                return 1;
        }
    }

    public static class CompareIP extends MyComparator {
        public final int compare(Object o1, Object o2) {
            ServerItem item1 = (ServerItem)o1;
            ServerItem item2 = (ServerItem)o2;
            if (item1.ip()!=null)
                return item1.ip().compareToIgnoreCase(item2.ip());
            else
                return 1;
        }
    }

    public static class CompareN1 extends MyComparator {
        public final int compare(Object o1, Object o2) {
            ServerItem item1 = (ServerItem)o1;
            ServerItem item2 = (ServerItem)o2;
            if (item1.n1()<item2.n1())
                return -1;
            else if (item1.n1()==item2.n1())
                return 0;
            else
                return 1;
        }
    }
    
    public static class CompareN2 extends MyComparator {
        public final int compare(Object o1, Object o2) {
            ServerItem item1 = (ServerItem)o1;
            ServerItem item2 = (ServerItem)o2;
            if (item1.n2()<item2.n2())
                return -1;
            else if (item1.n2()==item2.n2())
                return 0;
            else
                return 1;
        }
    }
}

// $Log: ServerItem.java,v $
// Revision 1.4  2002/07/09 22:13:33  fortun
// New realIp() and realPort() methods (unused but fun)
//
// Revision 1.3  2002/07/07 12:39:31  fortun
// Sorting now ignores case
//
// Revision 1.2  2002/05/27 22:10:27  fortun
// Added some comparators (for sorting)
//
// Revision 1.1.1.1  2002/05/21 21:26:13  fortun
//
//
