//
//  BlocSpeed.java
//  CocoDonkey
//  $Id: UploadSpeed.java,v 1.2 2002/08/21 21:50:22 fortun Exp $
//
//  Created by Fred Bonzoun on Sun May 19 2002.
//  Copyright (c) 2002 Bonzoun. All rights reserved.
//
//  This library is free software; you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published
//  by the Free Software Foundation; either version 2.1 of the License, or
//  (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//

package net.bonzoun.cocodonkey;

public class UploadSpeed {

    private int initBlocCount;
    private long initTime;
    private int curBlocCount;
    private long curTime;

    public UploadSpeed() {
    }

    public int blocSize() {
        return 8000;
    }

    public void setBytesCount(int n) {
        setBlocCount(n/blocSize());
    }
    
    public void setBlocCount(int n) {
        long t = System.currentTimeMillis();
        if (curTime==0 || t-curTime > 10000) {
            initBlocCount = curBlocCount;
            initTime = curTime;
            curBlocCount = n;
            curTime = System.currentTimeMillis();
        }
    }

    public double speed() {
        if (initTime==0)
            return -1;
        return (curBlocCount-initBlocCount)*(float)blocSize()/(curTime-initTime);
    }
}

// $Log: UploadSpeed.java,v $
// Revision 1.2  2002/08/21 21:50:22  fortun
// Handles bytes instead of blocs
//
// Revision 1.1.1.1  2002/05/21 21:26:13  fortun
//
//
