 //
 //  net_bonzoun_cocodonkey_SshTunnel.h.c
 //  CocoDonkey
 //  $Id: net_bonzoun_cocodonkey_SshTunnel.m,v 1.1 2002/05/25 23:42:43 fortun Exp $
 //
 //  Created by Fred Bonzoun on Thu May 25 2002.
 //  Copyright (c) 2002 Bonzoun. All rights reserved.
 //
 //  This library is free software; you can redistribute it and/or modify
 //  it under the terms of the GNU Lesser General Public License as published
 //  by the Free Software Foundation; either version 2.1 of the License, or
 //  (at your option) any later version.
 //
 //  This library is distributed in the hope that it will be useful,
 //  but WITHOUT ANY WARRANTY; without even the implied warranty of
 //  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 //  GNU Lesser General Public License for more details.
 //
 //  You should have received a copy of the GNU Lesser General Public License
 //  along with this program; if not, write to the Free Software
 //  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 //

#include <stdlib.h>
#include <unistd.h>
#include <errno.h>

#include <Foundation/Foundation.h>

#include "net_bonzoun_cocodonkey_SshTunnel.h"

JNIEXPORT jint JNICALL Java_net_bonzoun_cocodonkey_SshTunnel_run (JNIEnv *env, jclass self, jstring file, jobjectArray args, jobjectArray envp) {
    const char *s;
    NSString *nsFile;
    jsize nbArgs, nbEnvp;
    jstring obj;
    int i;
    NSMutableArray *nsArgs;

    // The directory
    s = (*env)->GetStringUTFChars(env, file, NULL);
    nsFile = (NSString *)[NSString stringWithCString:s];
    (*env)->ReleaseStringUTFChars(env, file, s);
    // The arguments
    nbArgs = (*env)->GetArrayLength(env, args);
    nsArgs = [NSMutableArray array];
    for(i=0; i<nbArgs; i++) {
        obj = (jstring)(*env)->GetObjectArrayElement(env, args, i);
        s = (*env)->GetStringUTFChars(env, obj, NULL);
        [nsArgs addObject:[NSString stringWithCString:s]];
        (*env)->ReleaseStringUTFChars(env, obj, s);
    }
    // The environment
    nbEnvp = (*env)->GetArrayLength(env, envp);
    for(i=0; i<nbEnvp; i++) {
        obj = (jstring)(*env)->GetObjectArrayElement(env, envp, i);
        s = (*env)->GetStringUTFChars(env, obj, NULL);
        putenv(s);
        (*env)->ReleaseStringUTFChars(env, obj, s);
    }

    NSLog(@"Cmd: %@ %@", [nsFile lastPathComponent], nsArgs);
    [NSTask launchedTaskWithLaunchPath:nsFile arguments:nsArgs];
    
    return 0;
}

JNIEXPORT jboolean JNICALL Java_net_bonzoun_cocodonkey_SshTunnel_kill (JNIEnv * env, jclass self, jint pid) {
    return 1;
}
